using Edu.Common.Enum;
using Edu.Model.Entity.WeChat;
using Edu.Model.ViewModel.WeChat;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.WeChat
{
    /// <summary>
    /// 企业微信渠道活码仓储层
    /// </summary>
    public class RB_WeChat_ChannelRepository : BaseRepository<RB_WeChat_Channel>
    {
        /// <summary>
        /// 获取分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="count"></param>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_WeChat_Channel_ViewModel> GetPageList(int pageIndex,int pageSize,out long count, RB_WeChat_Channel_ViewModel demodel)
        {
            DynamicParameters parameters = new DynamicParameters();
            string where = $@" 1=1 and r.{nameof(RB_WeChat_Channel_ViewModel.Status)} =0";
            if (demodel.Group_Id > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Channel_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (demodel.ChannelGroupId > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Channel_ViewModel.ChannelGroupId)} ={demodel.ChannelGroupId}";
            }
            if (demodel.Type > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Channel_ViewModel.Type)} ={demodel.Type}";
            }
            if (!string.IsNullOrEmpty(demodel.Name))
            {
                where += $@" and r.{nameof(RB_WeChat_Channel_ViewModel.Name)} like @Name";
                parameters.Add("Name", "%" + demodel.Name + "%");
            }

            string sql = $@" 
SELECT * From RB_WeChat_Channel r
WHERE {where} 
ORDER BY r.Id DESC ";
            return GetPage<RB_WeChat_Channel_ViewModel>(pageIndex, pageSize, out count, sql, parameters).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_WeChat_Channel_ViewModel> GetList(RB_WeChat_Channel_ViewModel demodel)
        {
            DynamicParameters parameters = new DynamicParameters();
            string where = $@" 1=1 and r.{nameof(RB_WeChat_Channel_ViewModel.Status)} =0";
            if (demodel.Group_Id > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Channel_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (demodel.ChannelGroupId > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Channel_ViewModel.ChannelGroupId)} ={demodel.ChannelGroupId}";
            }
            if (demodel.Type > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Channel_ViewModel.Type)} ={demodel.Type}";
            }
            if (!string.IsNullOrEmpty(demodel.Name))
            {
                where += $@" and r.{nameof(RB_WeChat_Channel_ViewModel.Name)} like @Name";
                parameters.Add("Name", "%" + demodel.Name + "%");
            }

            string sql = $@" 
SELECT * From RB_WeChat_Channel r
WHERE {where} 
ORDER BY r.Id DESC ";
            return Get<RB_WeChat_Channel_ViewModel>(sql, parameters).ToList();
        }

        /// <summary>
        /// 获取用户所在的备用名单列表
        /// </summary>
        /// <param name="group_Id"></param>
        /// <param name="transferUserId"></param>
        /// <returns></returns>
        public List<RB_WeChat_Channel_ViewModel> GetChannelBackUpEmpForUser(int group_Id, int transferUserId)
        {
            string sql = $@"select * from rb_wechat_channel where `Status` =0 and Group_Id ={group_Id} and EmpAddLimit =1 and FIND_IN_SET({transferUserId},EmpBackUp)";
            return Get<RB_WeChat_Channel_ViewModel>(sql).ToList();
        }
    }
}
